// ---------------------------------------------------------------------------------------------------------------------
//	PhotoChrome v5.xx - Atari ST interlaced image reduction framework
//	1991-2012 Douglas Little (d.m.l)
// ---------------------------------------------------------------------------------------------------------------------
//	special thanks to:
//
//		evil@DHS for noticing faults, making additional suggestions & testing ideas
//		Frank B for encouraging me back into Atari land
//		ppera for feedback and suggestions re: stream conversion for his CATA video project
//		Vincent Riviere's port of GCC 4.x.x for MiNT/TOS
//		various members of Atari-Forum for adding their 2p (you know who you are!)
//		*all* users of PhotoChrome, Apex etc. - past and future
// ---------------------------------------------------------------------------------------------------------------------

#ifndef ditherunit_h_
#define ditherunit_h_

// ====================================================================
//  dither unit
// ====================================================================

#include "lcg.h"

// --------------------------------------------------------------------
// object representing a dither implementation
// --------------------------------------------------------------------

class DitherUnit : public LCG
{
protected:
	
	signed short field_;
	signed short fields_;
	signed short colourdepth_;
	float dither_level_;
	
public:

	DitherUnit(signed short _field, signed short _colourdepth, signed short _fields, float _dither_level);

	void reset();
	virtual void onReset() { }
	
	//virtual signed short sample(signed short _x, signed short _y) = 0;
	virtual void fsample(signed short _x, signed short _y, float& _xadj, float& _yadj, float& _zadj) { }
};

// --------------------------------------------------------------------

#endif // ditherunit_h_
