// ---------------------------------------------------------------------------------------------------------------------
//	PhotoChrome v5.xx - Atari ST interlaced image reduction framework
//	1991-2012 Douglas Little (d.m.l)
// ---------------------------------------------------------------------------------------------------------------------
//	special thanks to:
//
//		evil@DHS for noticing faults, making additional suggestions & testing ideas
//		Frank B for encouraging me back into Atari land
//		ppera for feedback and suggestions re: stream conversion for his CATA video project
//		Vincent Riviere's port of GCC 4.x.x for MiNT/TOS
//		various members of Atari-Forum for adding their 2p (you know who you are!)
//		*all* users of PhotoChrome, Apex etc. - past and future
// ---------------------------------------------------------------------------------------------------------------------

#ifndef lcg_h_
#define lcg_h_

// --------------------------------------------------------------------
// object representing LCG/PRNG state
// --------------------------------------------------------------------

class LCG
{
	unsigned long state_;
	
public:
	
	LCG(unsigned long _seed)
		: state_(_seed)
	{
	}
	
	void reset(unsigned long _seed)
	{
		state_ = _seed;
	}
	
	inline unsigned short lcg_sample()
	{
		state_ = (state_ * 19387) + 27791;
		return (state_ >> 15) & 255;
	}
	
	inline unsigned long lcg_sample24()
	{
		state_ = (state_ * 19387) + 27791;
		return (state_ >> 8) & 0xffffff;
	}	
};

// --------------------------------------------------------------------

#endif // lcg_h_
