// ---------------------------------------------------------------------------------------------------------------------
//	PhotoChrome v5.xx - Atari ST interlaced image reduction framework
//	1991-2012 Douglas Little (d.m.l)
// ---------------------------------------------------------------------------------------------------------------------
//	special thanks to:
//
//		evil@DHS for noticing faults, making additional suggestions & testing ideas
//		Frank B for encouraging me back into Atari land
//		ppera for feedback and suggestions re: stream conversion for his CATA video project
//		Vincent Riviere's port of GCC 4.x.x for MiNT/TOS
//		various members of Atari-Forum for adding their 2p (you know who you are!)
//		*all* users of PhotoChrome, Apex etc. - past and future
// ---------------------------------------------------------------------------------------------------------------------

// ====================================================================
// 	generic reduction unit for PCS files
// ====================================================================
//	note: this bit is volatile - to be significantly refactored!
// ====================================================================

#include "common.h"
#include "config.h"

#include "FreeImage.h"

#include "imagepkg.h"
#include "pcsimage_std_sgl.h"

extern Arguments g_allargs;

// --------------------------------------------------------------------

PCSImage_std_sgl::PCSImage_std_sgl(const char* const _name, int _w, int _h, int _d, int _np, int _ns)
	: PCSImage(_name, _w, _h, _d, _np, _ns)
{

	framebuffer_words_ = ((display_width_ >> 4) * display_planes_) * display_height_;
	//palettebuffer_words_ = 16*((3 * (display_height_-1)) + 1);
	palettebuffer_words_ = palettebuffer_stride_ * display_height_;
	
	fields_ = 1;

	for (int f = 0; f < fields_; ++f)
	{
		bitmaps_[f] = new word_t[framebuffer_words_ + 4];
		if (!bitmaps_[f]) { printf("error - could not allocate memory for framebuffer!\n"); getchar(); exit(1); }
		palettes_[f] = new word_t[palettebuffer_words_ + 4];
		if (!palettes_[f]) { printf("error - could not allocate memory for palettebuffer!\n"); getchar(); exit(1); }
	}
}	

// --------------------------------------------------------------------

